--require ("defines")

function makeReplaceTable ()
	if not (global) then global = {} end
	if (global.replaceTable) then return end
	global.replaceTable = {
		{name = "transport-belt", type = "transport-belt" , tier = 1},
		--{name = "underground-belt", type = "underground-belt" , tier = 1},
		{name = "loader", type = "loader" , tier = 1},
		{name = "splitter", type = "splitter" , tier = 1},

		{name = "fast-transport-belt", type = "transport-belt" , tier = 2},
		--{name = "fast-underground-belt", type = "underground-belt" , tier = 2},
		{name = "fast-loader", type = "loader" , tier = 2},
		{name = "fast-splitter", type = "splitter" , tier = 2},

		{name = "express-transport-belt", type = "transport-belt" , tier = 3},
		--{name = "express-underground-belt", type = "underground-belt" , tier = 3},
		{name = "express-loader", type = "loader" , tier = 3},
		{name = "express-splitter", type = "splitter" , tier = 3}
		}
end


script.on_event(defines.events.on_preplayer_mined_item, function (event)
	event_if_replace (event, "first")
end)


script.on_event(defines.events.on_built_entity, function (event)
	event_if_replace (event, "second")
end)


script.on_event(defines.events.on_tick, function (event)
	on_tick_handler(event)	
end)


function event_if_replace (event, tstring)
	local player_index = event.player_index
	local entity = event.entity or event.created_entity
	try_init ()
	local tick = game.tick
	if tstring == "first" then
		 -- printAll("first")
		global.event_replace[tick] = {}
		global.event_replace_valid = true
		global.event_replace[tick].first = {}
		global.event_replace[tick].first.name = entity.name
		global.event_replace[tick].first.type = entity.type
		global.event_replace[tick].first.position = entity.position
		global.event_replace[tick].first.direction = entity.direction
		global.event_replace[tick].first.surface = entity.surface
		global.event_replace[tick].first.player_index = player_index
		global.event_replace[tick].first.entity = entity
		
	elseif ((tstring == "second") and 
			(global.event_replace_valid) and 
			(global.event_replace[tick])) then
		 -- printAll("second")
		local first_position = global.event_replace[tick].first.position
		local second_position = entity.position
		if comparePositions (first_position, second_position) then
			-- -- printAll("positions ok")
			local first = global.event_replace[tick].first
			local second = {}
				second.name = entity.name
				second.type = entity.type
				second.position = entity.position
				second.direction = entity.direction
				second.surface = entity.surface
				second.player_index = player_index
				second.entity = entity
				
				handler_event_on_replace (first, second)
				
				global.event_replace_valid = false
		end
	elseif global.event_replace[tick] then
		-- do nothing
	elseif global.event_replace[tick] == tick then
		-- do nothing
	else 
		global.event_replace = nil
	end
end


function handler_event_on_replace (first, second)
	 -- printAll("it was replacing!")
	
	local surface = first.surface or second.surface
	local position = first.position or second.position
	local direction = first.direction or second.direction or 0
	local newElement = {}
	newElement.type = getType(second.name)
	newElement.tier = getTier(second.name)
	newElement.tierOld = getTier(first.name)
	newElement.name = getNameFromTypeAndTier (newElement.type, newElement.tier)
	newElement.surface = second.surface
	newElement.position = second.position
	newElement.direction = second.direction
	newElement.player_index = second.player_index
	local elements = findElements (newElement)
	if elements then 
		elementsToTable (elements, " from #106")
	end
end


function try_init ()
	if not (global) then global = {} end
	if not (global.event_replace) then global.event_replace = {} end
	if not (global.elementsTable) then global.elementsTable = {} end
	
	-- global.event_replace = {}
end


function on_tick_handler(event)
	
	if not ((game.tick + 1) % 6 == 0) then return end -- ten times pro second
	if not (global and global.elementsTable) then return end
	local n = first_from_table(global.elementsTable)
	if not n then 
		global.elementsTable = nil
		printAll (global.elementsTable)
		printAll ("table is empty, destroyed")
		return
	end
	
	local element = global.elementsTable[n]
	local player = game.players[element.player_index]

	if  not (take_one_item_or_false(player, element.name)) then
		printAll ("You have no item " .. element.name .. ", [" .. n .. "] was destroyed")
		global.elementsTable[n] = nil
		return
	end
	
	create_entity(element, player)

	-- find next
	local elements = findElements (element)
	
	if elements then 
		elementsToTable (elements, " from #145")
	end

	global.elementsTable[n] = nil
	
end


function create_entity(element, player)
	local player = player or  game.players[element.player_index]
	player.surface.create_entity{
		name=element.name, 
		position=element.position, 
		direction=element.direction, 
		fast_replace=true, 
		player = player, 
		force = player.force}
end	


function take_one_item_or_false(player, item_name)
	if player.get_item_count(i) > 0 then
		player.remove_item({name=item_name})
		return true
	end
	return false
end	


function first_from_table(table)
	for i, v in pairs (global.elementsTable) do
		return i
	end
	return false
end


function elementsToTable (elements, text)
	local text = text or ""
	if not (elements) then 
		printAll ("#183 - no elements" .. text)
		return 
	end

	for i, element in pairs (elements) do
		addToTable (element)
	end
end

function findElements (element)
	local entities = findNeighborEntities (element)
		printAll ("#199 NeighborEntities: " .. #entities)
	local elements = {} 
	for i, entity in pairs (entities) do
		if isNewTier (entity, element) then
			elements[#elements+1] = newElement (entity, element)
		end
	end
end


----------------------------------
-------------- utils -------------
----------------------------------


function newElement (entity, element)
	local newElement = {}
	newElement.type = getType(entity.name)
	newElement.tier = getTier(element.name)
	newElement.tierOld = getTier(entity.name)
	newElement.name = getNameFromTypeAndTier (newElement.type, newElement.tier)
	newElement.surface = entity.surface
	newElement.position = entity.position
	newElement.direction = entity.direction
	newElement.player_index = element.player_index
	return newElement
end


function isNewTier (entity, element)
	if getTier(entity.name)==element.tier then 
		return false -- there is nothing to do
	else
		return true
	end
end


function findNeighborEntities (element) -- or entity, why not
	local surface = element.surface
	local direction = element.direction
	local position = element.position
	makeReplaceTable ()
	local neighbors = {}
	
	for i = direction, direction + 6, 2 do -- {direction, direction +2, direction +4, direction +6}
		local nDir = normDirection(i) -- {0,2,4,6} or {2,4,6,0} or {4,6,0,2} or {6,0,2,4}
		local mPos = directionToPosition(nDir, position)
		for j, value in pairs (global.replaceTable) do
			local entity = surface.find_entity(value.name, mPos) 
			if entity then
				if isConnected (nDir, direction, entity.direction)
					then
				-- connected
				printAll ("#254 "..nDir.." neighbor is " .. value.name)
				printAll ({entity.position, entity.direction})
				neighbors[#neighbors+1] = entity
				end
			else -- for splitter	is dualism
				-- first connection of splitter
				entity = surface.find_entity(value.name, directionToPosition(nDir, position, 0.5))
				if entity and isConnected (nDir, direction, entity.direction) then
					printAll ("#261 "..nDir.." neighbor is " .. value.name)
					printAll ({entity.position, entity.direction})
					neighbors[#neighbors+1] = entity
				end
				-- second connection of splitter
				entity = surface.find_entity(value.name, directionToPosition(nDir, position, -0.5))
				if entity and isConnected (nDir, direction, entity.direction) then
					printAll ("#267 "..nDir.." neighbor is " .. value.name)
					printAll ({entity.position, entity.direction})
					neighbors[#neighbors+1] = entity
				end
			end
		end
	end
	return neighbors -- entities, amount from 0 to 6, i think
end

function isConnected (a, b, c)
	-- isConnected (nDir, direction, entity.direction)
	--(((nDir == direction) or (nDir) == ((entity.direction+4)%8)) and not ((direction) == ((entity.direction+4)%8)))
	return (((a == b) or (a) == ((c+4)%8)) and not ((b) == ((c+4)%8)))
end

function addEntity (entity, element)
	if not (entity) then return end
	local newElement = {}
	newElement.type = entity.type
	newElement.tier = element.tier
	newElement.tierOld = element.tier
	newElement.name = getNameFromTypeAndTier (entity.type, element.tier)
	newElement.position = entity.position
	newElement.direction = entity.direction
	newElement.player_index = element.player_index
	 -- printAll({"#303 newElement ", newElement.name, entity.type, element.tier})
	addToTable (newElement)
end


function addToTable (element)
	--global.elementsTable
	local nextID = getNextID (global.elementsTable) or 1
	global.elementsTable[nextID] = element
end


function getNextID (table)
	if not (table) then 
		printAll("#362 - no table")
		return nil
	end
	if not (type(table) == "table") then
		printAll("#366 - not table")
		return nil
	end
	local n = 0
	for i, v in pairs (table) do
			n = i
	end
	return n + 1
end


function getTier (entityName)
	makeReplaceTable ()
	for i, v in pairs (global.replaceTable) do
		if (entityName == v.name) then
			return v.tier
		end
	end
	printAll(entityName .. " is not in replaceTable! No tier. Error 379")
	return false
end


function getType (entityName)
	makeReplaceTable ()
	for i, v in pairs (global.replaceTable) do
		if (entityName == v.name) then
			return v.type
		end
	end
	printAll(entityName .. " is not in replaceTable! No type. Error 389")
	return false
end


function getNameFromTypeAndTier (type, tier)
	makeReplaceTable ()
	if not type then  printAll("#320 no type" )  return end
	if not tier then  printAll("#321 no tier" )  return end
	for i, v in pairs (global.replaceTable) do
		if ((type == v.type) and (tier == v.tier)) then
			return v.name
		end
	end
	printAll("#325 It was not in replaceTable! No name. Type:" .. type .. " tier: " .. tier)
	return false
end


function directionToPosition(direction, position, shift)
	-- makes position from direction, absolute or relative
	local newPosition = {x=0, y=0}
	local oldPosition = position or {x=0, y=0}
	direction = normDirection(direction)
	local shift = shift or 0
	if 			direction == 0 then newPosition = {	x=	-shift, 	y=	-1}
		elseif 	direction == 2 then newPosition = {	x=	1, 		y=	shift	}
		elseif 	direction == 4 then newPosition = {	x=	shift, 	y=	1		}
		elseif 	direction == 6 then newPosition = {	x=	-1, 		y=	-shift}
		else printAll("Wrong direction detected! The direction was " .. direction .. "! Error 417")
		return nil 
	end
	newPosition = {x = oldPosition.x + newPosition.x, y = oldPosition.y + newPosition.y}
	return newPosition
end


function normDirection(direction)
	return direction % 8
end


function comparePositions (pos1, pos2)
	if not (pos1 and pos2) then 
		printAll("no positions, error 437")
		return false 
	end
	if not ((type (pos1) == "table") and (type (pos2) == "table")) then 
		printAll("positions are not table, error 441")
		return false 
	end
	if ((pos1.x == pos2.x) and (pos1.y == pos2.y)) then return true end
	printAll("not same position, how? - error 443")
	return false
end


function tableContains(table, element)
  for i, value in pairs(table) do
    if value == element then
      return value
    end
	 if type(value) == "table" then
		local valueOrFalse = tableContains(value, element)
		if valueOrFalse then return i end
	 end
  end
  return false
end


function printAll(text)
	if type(text) == "table" then text = serpent.block(text, {comment = false}) end
	for player_index, player in pairs (game.players) do game.players[player_index].print (text) end
end